local RW = LibStub("AceAddon-3.0"):GetAddon("Raid Watch")

local plugin = RW:Plugin("Debugg")

RW.debug = true
function RW:D(...)
	if RW.debug then
		local str = ""
		for i = 1, select("#", ...) do
			local v = select(i, ...)
			if v then str = str..tostring(v) else str = str.."nil" end
			if i < select("#", ...) then str = str..", " end
		end
		RW:Msg(str, "RW-Debug: "..self:GetName()) 
	end
end

function plugin:OnRegister()
	--RW:RegisterMessage("RW_PluginRegistered")
	--RW:RegisterMessage("RW_BossRegistered")
	--RW:RegisterMessage("RW_PluginEnabled")
	--RW:RegisterMessage("RW_PluginDisabled")
	--RW:RegisterMessage("RW_JoinedParty", "PartyEvent")
	--RW:RegisterMessage("RW_PayerJoinedParty", "PartyEvent")
	--RW:RegisterMessage("RW_PlayerLeftParty", "PartyEvent")
	--RW:RegisterMessage("RW_LeftGroup", "PartyEvent")
	--RW:RegisterMessage("RW_Message", function(message, text, ...) RW:D(message, text, ...) end)
	--RW:RegisterMessage("RW_BarFinished")
	RW:RegisterMessage("RW_NewMonitorZone", "GeneralDisplay")
	RW:RegisterMessage("RW_BossModFound", "GeneralDisplay")
end

function plugin:OnPluginEnable()
end

function plugin:GetOptions()
	local option = {
		type = "group",
		name = "Debugg",
		args = {
			Messages = {
				type = "group",
				name = "Messages",
				guiInline = true,
				args = {
					debug1 = {
						type = "execute",
						name = "Message 1",
						func = function(info) self:SendMessage("RW_Message", info[#info], math.random(), math.random(), math.random()) end
					},
					debug2 = {
						type = "execute",
						name = "Message 2",
						func = function(info) self:SendMessage("RW_Message", info[#info], math.random(), math.random(), math.random()) end
					}
				}
			},
			Bars = {
				type = "group",
				name = "Bars",
				guiInline = true,
				args = {
					debug1 = {
						type = "execute",
						name = "Start",
						func = function(info) self:SendMessage("RW_StartBar", floor(math.random() * 10), math.random() * 100, info[#info]) end
					},
					debug2 = {
						type = "execute",
						name = "Stop",
						func = function(info) self:SendMessage("RW_CancelBar", floor(math.random() * 10)) end
					}
				}
			},
			HealthBars = {
				type = "group",
				name = "Healthframe",
				guiInline = true,
				args = {
					debug1 = {
						type = "execute",
						name = "Add",
						func = function(info) self:SendMessage("RW_AddHealthFrame", 29548) end
					},
					debug2 = {
						type = "execute",
						name = "Remove",
						func = function(info) self:SendMessage("RW_RemoveHealthFrame", 29548) end
					}
				}
			},
			RangeCheck = {
				type = "group",
				name = "Range Check",
				guiInline = true,
				args = {
					debug1 = {
						type = "execute",
						name = "Show",
						func = function(info) self:SendMessage("RW_ShowRangeCheck", true) end
					},
					debug2 = {
						type = "execute",
						name = "Hide",
						func = function(info) self:SendMessage("RW_ShowRangeCheck", false) end
					}
				}
			}
		},
	}
	return option
end

function RW:RW_PluginRegistered(event, plugin)
	self:D("New plugin registered: "..plugin:GetName())
	plugin.D = RW.D
end
function RW:RW_BossRegistered(event, plugin)
	self:D("New boss loaded: "..plugin:GetName())
	plugin.D = RW.D
end

function RW:PartyEvent(message, ...)
	self:D(message, ...)
end

function RW:RW_BarFinished(message, id, text, icon, color)
	self:SendMessage("RW_Message", text, nil, nil, nil, icon)
end

function RW:RW_PluginEnabled(message, plugin)
	self:D("Plugin Enabled:", plugin:GetName())
end

function RW:RW_PluginDisabled(message, plugin)
	self:D("Plugin Disabled:", plugin:GetName())
end

function RW:GeneralDisplay(message, ...)
	self:D(message, ...)
end
